import { QueryList, OnInit } from '@angular/core';
import { Subject } from 'rxjs';
import { services, filters } from 'typescript-angular-utilities';
import __array = services.array;
import __genericSearchFilter = services.genericSearchFilter;
import { IDataSource } from './dataSources/index';
import { DataPager } from './paging/dataPager/dataPager.service';
import { IColumn } from './column';
import { ISortDirections, SortManagerService } from './sorts/index';
import { CardComponent } from './card/card';
import { CardContentTemplate, CardFooterTemplate } from '../cards/index';
import { ContainerHeaderTemplate, ContainerFooterTemplate, ColumnContentTemplate } from './templates/index';
import { ColumnHeaderTemplate } from './templates/columnHeader.template';
import { ISaveAction } from '../form/form';
import { CardContainerBuilder, CardContainerType } from './builder/cardContainerBuilder.service';
export declare const cardContainerInputs: {
    builder: string;
    save: string;
    searchPlaceholder: string;
};
export declare const defaultMaxColumnSorts: number;
export declare class CardContainerComponent<T> implements OnInit {
    builder: CardContainerBuilder;
    save: ISaveAction<any>;
    searchPlaceholder: string;
    dataSource: IDataSource<T>;
    filters: filters.IFilter[];
    searchFilter: __genericSearchFilter.IGenericSearchFilter;
    paging: boolean;
    columns: IColumn<any>[];
    clickableCards: boolean;
    maxColumnSorts: number;
    permanentFooters: boolean;
    saveWhenInvalid: boolean;
    sortDirection: ISortDirections;
    numberSelected: number;
    numberSelectedChanges: Subject<number>;
    arrayUtility: __array.IArrayUtility;
    injectedPager: DataPager;
    sortManager: SortManagerService;
    type: CardContainerType;
    containerHeader: ContainerHeaderTemplate;
    containerFooter: ContainerFooterTemplate;
    cardContent: CardContentTemplate;
    cardFooter: CardFooterTemplate;
    columnTemplates: QueryList<ColumnContentTemplate>;
    columnHeaders: QueryList<ColumnHeaderTemplate>;
    cardChildren: QueryList<CardComponent<T>>;
    readonly cards: CardComponent<T>[];
    readonly hasItems: boolean;
    constructor(array: __array.ArrayUtility, pager: DataPager, sortManager: SortManagerService);
    ngOnInit(): void;
    openCard(): boolean;
    sort(column: IColumn<any>): void;
    getColumnTemplate(columnName: string): ColumnHeaderTemplate;
    private syncFilters();
    private setupPaging();
    private lookupColumn(label);
}
