/// <reference types="moment-timezone" />
import * as moment from 'moment';
import { filters, services } from 'typescript-angular-utilities';
import __date = services.date;
import __transform = services.transform;
export interface IDateFilterValue {
    dateFrom: moment.Moment;
    dateTo: moment.Moment;
}
export interface IDateFilterSettings {
    type: string;
    valueSelector: {
        (item: any): moment.Moment;
    } | string;
    showClear?: boolean;
    useDateRange?: boolean;
    useTime?: boolean;
    label?: string;
}
export interface IDateFilter extends filters.ISerializableFilter<IDateFilterValue> {
    dateFrom: moment.Moment;
    dateTo: moment.Moment;
    useTime: boolean;
    type: string;
    dateRange: boolean;
    filter(item: any): boolean;
}
export declare class DateFilter extends filters.SerializableFilter<IDateFilterValue> implements IDateFilter {
    useTime: boolean;
    dateRange: boolean;
    private _dateFrom;
    private _dateTo;
    private valueSelector;
    type: string;
    showClear: boolean;
    useDateRange: boolean;
    label: string;
    template: string;
    private date;
    private transformService;
    dateFrom: moment.Moment;
    dateTo: moment.Moment;
    constructor(settings: IDateFilterSettings, dateUtility: __date.IDateUtility, transformService: __transform.ITransformService);
    filter(item: any): boolean;
    serialize(): IDateFilterValue;
    private getValue(item);
}
