/// <reference types="angular" />
import { filters, services } from 'typescript-angular-utilities';
import * as angular from 'angular';
import __object = services.object;
import __transform = services.transform;
export interface ISelectFilterSettings<TDataType, TFilterType> {
    valueSelector: string | {
        (item: TDataType): any;
    };
    comparer?: IEqualityFunction<TFilterType>;
    options?: any[];
    getOptions?: {
        (): angular.IPromise<any[]>;
    };
    label?: string;
    displayNameSelector?: string | {
        (item: any): string;
    };
    nullOption?: string;
}
export interface ISelectFilter<T> extends filters.ISerializableFilter<any> {
    selectedValue: any;
}
export interface IEqualityFunction<TFilterType> {
    (item1: TFilterType, item2: TFilterType): boolean;
}
export declare class SelectFilter<TDataType, TFilterType> extends filters.SerializableFilter<TFilterType> implements ISelectFilter<TDataType> {
    type: string;
    private _selectedValue;
    private valueSelector;
    private comparer;
    options: any[];
    getOptions: {
        (): angular.IPromise<any[]>;
    };
    label: string;
    displayNameSelector: string | {
        (item: any): string;
    };
    nullOption: string;
    template: string;
    object: __object.IObjectUtility;
    transformService: __transform.ITransformService;
    selectedValue: TFilterType;
    constructor(settings: ISelectFilterSettings<TDataType, TFilterType>, object: __object.IObjectUtility, transformService: __transform.ITransformService);
    filter(item: TDataType): boolean;
    serialize(): TFilterType;
    private getValue(item);
}
